summaryrefslogtreecommitdiff
path: root/script/build
diff options
context:
space:
mode:
authorLeah Rowe <leah@libreboot.org>2023-10-25 11:40:02 +0100
committerLeah Rowe <leah@libreboot.org>2023-10-25 12:58:52 +0100
commit5f6ba01d414e2d98d7db049347b8c5c5d125ba61 (patch)
treeae960452213613ef777c0aaf667402c62d7818dc /script/build
parentdf031d422a1c0b76edbea1cdee98796ad3d1392f (diff)
include/option.sh: fix i945 bootblock copy
it wasn't being copied right the roms under elf/ were being copied, but not the ones under bin/ - i need to audit it further for now, i run modify_coreboot_roms from build/roms instead of update/trees so, the ones under elf/ no longer have bootblocks copied. it's only done in bin/ Signed-off-by: Leah Rowe <leah@libreboot.org>
Diffstat (limited to 'script/build')
-rwxr-xr-xscript/build/roms28
1 files changed, 28 insertions, 0 deletions
diff --git a/script/build/roms b/script/build/roms
index 37ee0aab..f19f7328 100755
--- a/script/build/roms
+++ b/script/build/roms
@@ -388,9 +388,37 @@ moverom() {
[ -d "${newrom%/*}" ] || x_ mkdir -p "${newrom%/*}/"
[ "${vendorfiles}" = "n" ] && newrom="${newrom%.rom}_noblobs.rom"
+
+ x_ modify_coreboot_rom
x_ cp "${rompath}" "${newrom}"
}
+modify_coreboot_rom()
+{
+ tmpmvrom="$(mktemp -t rom.XXXXXXXXXX)"
+ x_ rm -f "${tmpmvrom}"
+
+ if [ "${romtype}" = "d8d16sas" ]; then
+ # pike2008 roms hang seabios. an empty rom will override
+ # the built-in one, thus disabling all execution of it
+ x_ touch "${tmpmvrom}"
+ for deviceID in "0072" "3050"; do
+ x_ "${cbfstool}" "${rompath}" add -f "${tmpmvrom}" \
+ -n "pci1000,${deviceID}.rom" -t raw
+ done
+ elif [ "${romtype}" = "i945 laptop" ]; then
+ # for bucts-based installation method from factory bios
+ dd if="${rompath}" of="${tmpmvrom}" bs=1 \
+ skip=$(($(stat -c %s "${rompath}") - 0x10000)) \
+ count=64k || err "modrom 1, copy bootblock"
+ dd if="${tmpmvrom}" of="${rompath}" bs=1 \
+ seek=$(($(stat -c %s "${rompath}") - 0x20000)) count=64k \
+ conv=notrunc || err "modrom 2, insert new bootblock"
+ x_ rm -f "${tmpmvrom}"
+ fi
+ x_ rm -f "${tmpmvrom}"
+}
+
usage()
{
cat <<- EOF